## mingw-w64-gr-0.73.5-1.src.tar.zst

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.1 FATAL_ERROR)

list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_LIST_DIR}/cmake")
include(GetVersionFromGit)
get_version_from_git(GR_VERSION GR_VERSION_FULL)

project(
  GR
  VERSION ${GR_VERSION}
  LANGUAGES C CXX
)

include(GNUInstallDirs)
include(CheckCXXCompilerFlag)

# Honor `C_VISIBILITY_PRESET hidden` and `CXX_VISIBILITY_PRESET hidden` in static libraries
cmake_policy(SET CMP0063 NEW)

check_cxx_compiler_flag("-Werror=implicit" ERROR_IMPLICIT_SUPPORTED)
if(ERROR_IMPLICIT_SUPPORTED)
  set(COMPILER_OPTION_ERROR_IMPLICIT
      "-Werror=implicit"
      CACHE INTERNAL "Compiler flag for generating errors on implicit declarations"
  )
else()
  set(COMPILER_OPTION_ERROR_IMPLICIT
      ""
      CACHE INTERNAL "Compiler flag for generating errors on implicit declarations"
  )
endif()

if(UNIX)
  if(CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
    set(CMAKE_INSTALL_PREFIX
        "/usr/local/gr"
        CACHE PATH "GR install prefix" FORCE
    )
  endif()
endif()
set(GR_DIRECTORY
    "${CMAKE_INSTALL_PREFIX}"
    CACHE STRING "Default value for GRDIR"
)
option(GR_BUILD_DEMOS "Build demos for GR" OFF)
option(GR_INSTALL "Create installation target for GR" ON)
option(GR_USE_BUNDLED_LIBRARIES "Use thirdparty libraries bundled with GR" OFF)
option(GR_MANUAL_MOC_AND_RCC "Manually run moc and rcc instead of relying on AUTOMOC and AUTORCC" OFF)
option(GR_FIND_QT5_BY_VARIABLES "Find Qt5 based on the variables Qt5_INCLUDE_DIR and Qt5_LIBRARY_DIR" OFF)
option(GR_PREFER_XCODEBUILD "Prefer xcodebuild to build macOS applications if available" ON)

if(GR_USE_BUNDLED_LIBRARIES)
  list(APPEND CMAKE_FIND_ROOT_PATH "${CMAKE_CURRENT_LIST_DIR}/3rdparty/build/")
  set(GR_THIRDPARTY_LIBRARY_PREFIX ${CMAKE_STATIC_LIBRARY_PREFIX})
  set(GR_THIRDPARTY_LIBRARY_SUFFIX ${CMAKE_STATIC_LIBRARY_SUFFIX})
else()
  set(GR_THIRDPARTY_LIBRARY_PREFIX ${CMAKE_SHARED_LIBRARY_PREFIX})
  set(GR_THIRDPARTY_LIBRARY_SUFFIX ${CMAKE_SHARED_LIBRARY_SUFFIX})
endif()

if(GR_FIND_QT5_BY_VARIABLES)
  list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_LIST_DIR}/cmake/optional/qt5")
endif()

if(WIN32)
  set(GR_PLUGIN_SUFFIX ".dll")
else()
  set(GR_PLUGIN_SUFFIX ".so")
endif()

if(APPLE)
  set(DEFAULT_SHARED_LIBRARY_SUFFIX ".dylib")
else()
  set(DEFAULT_SHARED_LIBRARY_SUFFIX "${GR_PLUGIN_SUFFIX}")
endif()

set(GR_SHARED_LIBRARY_SUFFIX
    "${DEFAULT_SHARED_LIBRARY_SUFFIX}"
    CACHE STRING "File suffix for shared libraries"
)

set(CMAKE_FIND_PACKAGE_PREFER_CONFIG
    TRUE
    CACHE BOOL ""
)

# Find the following packages always in system locations even if `GR_USE_BUNDLED_LIBRARIES` is set, because they are not
# located in 3rdparty
find_package(X11)
find_package(Fontconfig)
find_package(OpenGL OPTIONAL_COMPONENTS OpenGL)
if(${CMAKE_VERSION} VERSION_GREATER "3.16.0")
  find_package(
    Qt6
    OPTIONAL_COMPONENTS
      Widgets
      Core
      Network
      Gui
      PrintSupport
  )
endif()
find_package(
  Qt5
  OPTIONAL_COMPONENTS
    Widgets
    Core
    Network
    Gui
    PrintSupport
)
find_package(Qt4)
# CMake ships with a `FindLibXml2.cmake` module which does not configure needed libxml2 dependencies.
# Thus, use the `libxml2-config.cmake` config file shipped with libxml which configures dependencies correctly by
# skipping module search mode.
if(GR_USE_BUNDLED_LIBRARIES)
  # Find `LibXml2` only in 3rdparty but allow to find its dependencies in system directories
  # (`ONLY_CMAKE_FIND_ROOT_PATH` option is not inherited to `find_package` calls within the LibXml2 config file)
  find_package(LibXml2 NO_MODULE ONLY_CMAKE_FIND_ROOT_PATH)
else()
  find_package(LibXml2 NO_MODULE)
endif()

# Find the following packages only in 3rdparty, if `GR_USE_BUNDLED_LIBRARIES` is set
if(GR_USE_BUNDLED_LIBRARIES)
  set(CMAKE_FIND_ROOT_PATH_MODE_INCLUDE ONLY)
  set(CMAKE_FIND_ROOT_PATH_MODE_LIBRARY ONLY)
  set(CMAKE_FIND_ROOT_PATH_MODE_PACKAGE ONLY)
  set(CMAKE_FIND_ROOT_PATH_MODE_PROGRAM ONLY)
endif()
find_package(Freetype)
if(TARGET freetype AND NOT TARGET Freetype::Freetype)
  add_library(Freetype::Freetype ALIAS freetype)
endif()
find_package(Jpeg REQUIRED)
find_package(Libpng REQUIRED)
find_package(ZLIB REQUIRED)
find_package(Qhull REQUIRED)
if(TARGET Qhull::qhullstatic_r AND NOT TARGET Qhull::qhull_r)
  add_library(Qhull::qhull_r ALIAS Qhull::qhullstatic_r)
endif()
find_package(Tiff)
find_package(Ffmpeg 57.48.100)
find_package(glfw3)
if(TARGET glfw AND NOT TARGET Glfw::Glfw)
  add_library(Glfw::Glfw ALIAS glfw)
endif()
find_package(ZeroMQ)
if(NOT TARGET ZeroMQ::ZeroMQ)
  if(TARGET libzmq)
    add_library(ZeroMQ::ZeroMQ ALIAS libzmq)
  elseif(TARGET libzmq-static)
    add_library(ZeroMQ::ZeroMQ ALIAS libzmq-static)
    get_target_property(ZeroMQ_LIBRARY libzmq-static LOCATION)
  endif()
endif()
find_package(Cairo)
find_package(Agg)
find_package(Gs)
find_package(Expat)

if(APPLE)
  set(INSTALL_RPATH "${GR_DIRECTORY}/lib/;@loader_path/.")
else()
  set(INSTALL_RPATH "${GR_DIRECTORY}/lib/;$ORIGIN/.")
endif()

if(Qt4_FOUND
   OR (Qt5Widgets_FOUND
       AND Qt5Core_FOUND
       AND Qt5Network_FOUND
      )
   OR (Qt6Widgets_FOUND
       AND Qt6Core_FOUND
       AND Qt6Network_FOUND
      )
)
  if(GR_MANUAL_MOC_AND_RCC)
    if(NOT QT_MOC_EXECUTABLE)
      find_program(QT_MOC_EXECUTABLE moc CMAKE_FIND_ROOT_PATH_BOTH)
    endif()
    if(NOT QT_MOC_EXECUTABLE)
      message(FATAL_ERROR "Could not find moc but GR_MANUAL_MOC_AND_RCC is set.")
    endif()
    if(NOT QT_RCC_EXECUTABLE)
      find_program(QT_RCC_EXECUTABLE rcc CMAKE_FIND_ROOT_PATH_BOTH)
    endif()
    if(NOT QT_RCC_EXECUTABLE)
      message(FATAL_ERROR "Could not find rcc but GR_MANUAL_MOC_AND_RCC is set.")
    endif()
  endif()
endif()
if(Qt4_FOUND)
  set(QT4_MOC_INCLUDE_FLAGS "")
  foreach(DIR IN LISTS QT_INCLUDE_DIR)
    set(QT4_MOC_INCLUDE_FLAGS ${QT4_MOC_INCLUDE_FLAGS} -I${DIR})
  endforeach()
  if(NOT DEFINED Qt4_LIBRARY_DIR)
    get_filename_component(Qt4_LIBRARY_DIR "${QT_LIBRARY_DIR}/../.." ABSOLUTE)
  endif()
endif()
if(Qt5Widgets_FOUND
   AND Qt5Core_FOUND
   AND Qt5Network_FOUND
)
  set(QT5_MOC_INCLUDE_FLAGS "")
  foreach(DIR IN LISTS Qt5Core_INCLUDE_DIRS Qt5Gui_INCLUDE_DIRS Qt5Widgets_INCLUDE_DIRS)
    set(QT5_MOC_INCLUDE_FLAGS ${QT5_MOC_INCLUDE_FLAGS} -I${DIR})
  endforeach()
  if(NOT DEFINED Qt5_LIBRARY_DIR)
    get_filename_component(Qt5_LIBRARY_DIR "${Qt5_DIR}/../.." ABSOLUTE)
  endif()
endif()
if(Qt6Widgets_FOUND
   AND Qt6Core_FOUND
   AND Qt6Network_FOUND
)
  set(QT6_MOC_INCLUDE_FLAGS "")
  foreach(DIR IN LISTS Qt6Core_INCLUDE_DIRS Qt6Gui_INCLUDE_DIRS Qt6Widgets_INCLUDE_DIRS)
    set(QT6_MOC_INCLUDE_FLAGS ${QT6_MOC_INCLUDE_FLAGS} -I${DIR})
  endforeach()
  if(NOT DEFINED Qt6_LIBRARY_DIR)
    get_filename_component(Qt6_LIBRARY_DIR "${Qt6_DIR}/../.." ABSOLUTE)
  endif()
endif()

if(X11_FOUND)
  # older versions of FindX11.cmake set variables but do not create targets
  if(NOT TARGET X11::X11
     AND X11_INCLUDE_DIR
     AND X11_X11_LIB
     AND X11_Xft_LIB
  )
    add_library(X11::X11 UNKNOWN IMPORTED)
    set_target_properties(
      X11::X11
      PROPERTIES INTERFACE_INCLUDE_DIRECTORIES "${X11_INCLUDE_DIR}/"
                 IMPORTED_LINK_INTERFACE_LANGUAGES "C"
                 IMPORTED_LOCATION "${X11_X11_LIB}"
                 INTERFACE_LINK_LIBRARIES "${X11_Xft_LIB}"
    )
  endif()
  if(NOT TARGET X11::Xt
     AND X11_INCLUDE_DIR
     AND X11_Xt_LIB
     AND TARGET X11::X11
  )
    add_library(X11::Xt UNKNOWN IMPORTED)
    set_target_properties(
      X11::Xt
      PROPERTIES INTERFACE_INCLUDE_DIRECTORIES "${X11_INCLUDE_DIR}/"
                 IMPORTED_LINK_INTERFACE_LANGUAGES "C"
                 IMPORTED_LOCATION "${X11_Xt_LIB}"
                 INTERFACE_LINK_LIBRARIES "X11::X11"
    )
  endif()
endif()

set(GKS_SOURCES
    lib/gks/afm.c
    lib/gks/font.c
    lib/gks/socket.c
    lib/gks/ft.c
    lib/gks/malloc.c
    lib/gks/util.c
    lib/gks/compress.c
    lib/gks/gks.c
    lib/gks/mf.c
    lib/gks/win.c
    lib/gks/gksforbnd.c
    lib/gks/pdf.c
    lib/gks/wiss.c
    lib/gks/dl.c
    lib/gks/plugin.c
    lib/gks/error.c
    lib/gks/io.c
    lib/gks/ps.c
    lib/gks/resample.c
)

add_library(gks_static STATIC ${GKS_SOURCES})
add_library(gks_shared SHARED ${GKS_SOURCES})

foreach(LIBRARY gks_static gks_shared)
  if(LIBRARY MATCHES "static")
    set(GKS_LINK_MODE PUBLIC)
  else()
    set(GKS_LINK_MODE PRIVATE)
  endif()
  if(CMAKE_CXX_COMPILER_ID STREQUAL "MSVC")
    target_compile_definitions(${LIBRARY} PRIVATE _CRT_SECURE_NO_WARNINGS)
  endif()
  if(NOT ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "MSVC"))
    target_link_libraries(${LIBRARY} ${GKS_LINK_MODE} pthread)
    target_link_libraries(${LIBRARY} ${GKS_LINK_MODE} m)
  endif()
  if(FREETYPE_FOUND)
    target_link_libraries(${LIBRARY} ${GKS_LINK_MODE} Freetype::Freetype)
  else()
    target_compile_definitions(
      ${LIBRARY}
      ${GKS_LINK_MODE}
      NO_FT
    )
  endif()
  target_link_libraries(${LIBRARY} ${GKS_LINK_MODE} ZLIB::ZLIB)
  target_compile_definitions(
    ${LIBRARY}
    ${GKS_LINK_MODE}
    HAVE_ZLIB
  )
  if(UNIX)
    target_link_libraries(${LIBRARY} ${GKS_LINK_MODE} dl)
  elseif(WIN32)
    target_link_libraries(${LIBRARY} ${GKS_LINK_MODE} ws2_32)
    target_link_libraries(${LIBRARY} ${GKS_LINK_MODE} msimg32)
    target_link_libraries(${LIBRARY} ${GKS_LINK_MODE} gdi32)
  endif()
  if(NOT ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "MSVC"))
    target_compile_options(${LIBRARY} ${GKS_LINK_MODE} -pthread)
  endif()
  target_compile_options(${LIBRARY} PRIVATE ${COMPILER_OPTION_ERROR_IMPLICIT})
  target_include_directories(
    ${LIBRARY} PUBLIC $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/lib/gks/>
                      $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>
  )
  target_compile_definitions(${LIBRARY} PRIVATE GRDIR="${GR_DIRECTORY}")
  set_target_properties(
    ${LIBRARY}
    PROPERTIES C_STANDARD 90
               C_EXTENSIONS OFF
               C_STANDARD_REQUIRED ON
               POSITION_INDEPENDENT_CODE ON
               PREFIX "lib"
               IMPORT_PREFIX "lib"
               OUTPUT_NAME GKS
               INSTALL_RPATH "${INSTALL_RPATH}"
  )
endforeach()
unset(GKS_LINK_MODE)
if("${CMAKE_CXX_COMPILER_ID}" STREQUAL "MSVC")
  set_target_properties(gks_static PROPERTIES OUTPUT_NAME GKSstatic)
endif()
set_target_properties(gks_shared PROPERTIES SUFFIX "${GR_SHARED_LIBRARY_SUFFIX}" EXPORT_NAME GKS)
add_library(GR::GKS ALIAS gks_static)
file(WRITE ${CMAKE_CURRENT_BINARY_DIR}/gr_version.h
     "#ifndef GR_VERSION\n#define GR_VERSION \"${GR_VERSION_FULL}\"\n#endif\n"
)
set_source_files_properties(${CMAKE_CURRENT_BINARY_DIR}/gr_version.h PROPERTIES GENERATED TRUE)

set(GR_SOURCES
    lib/gr/boundary.c
    lib/gr/contour.c
    lib/gr/contourf.c
    lib/gr/delaunay.c
    lib/gr/gr.c
    lib/gr/grforbnd.c
    lib/gr/gridit.c
    lib/gr/image.c
    lib/gr/import.c
    lib/gr/interp2.c
    lib/gr/stream.c
    lib/gr/md5.c
    lib/gr/shade.c
    lib/gr/spline.c
    lib/gr/strlib.c
    lib/gr/text.c
    lib/gr/mathtex2.c
    lib/gr/mathtex2_kerning.c
    lib/gr/mathtex2.tab.c
    lib/gr/threadpool.c
    ${CMAKE_CURRENT_BINARY_DIR}/gr_version.h
)

add_library(gr_static STATIC ${GR_SOURCES})
add_library(gr_shared SHARED ${GR_SOURCES})

foreach(LIBRARY gr_static gr_shared)
  if(LIBRARY MATCHES "static")
    set(GR_LINK_MODE PUBLIC)
  else()
    set(GR_LINK_MODE PRIVATE)
  endif()
  target_link_libraries(${LIBRARY} ${GR_LINK_MODE} gks_static)
  if(NOT ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "MSVC"))
    target_link_libraries(${LIBRARY} ${GR_LINK_MODE} m)
  endif()
  target_link_libraries(${LIBRARY} ${GR_LINK_MODE} Qhull::qhull_r)
  target_link_libraries(${LIBRARY} ${GR_LINK_MODE} Jpeg::Jpeg)
  target_link_libraries(${LIBRARY} ${GR_LINK_MODE} Libpng::Libpng)
  if(WIN32)
    target_link_libraries(${LIBRARY} ${GR_LINK_MODE} ws2_32)
  endif()
  target_include_directories(
    ${LIBRARY} PUBLIC $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/lib/gr/>
                      $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>
  )

=== 3rdparty/expat/Makefile ===
ifeq ($(strip $(PREFIX)),)
override PREFIX = $(abspath $(CURDIR)/../build)
endif

VERSION = 2.4.8
EXPAT_EXTRA_CONFIGURE_FLAGS ?=
ifeq ($(shell uname),Darwin)
EXPAT_EXTRA_CONFIGURE_FLAGS += CFLAGS=-mmacosx-version-min=10.15
endif

ifeq ($(DOWNLOAD_CMD),)
ifneq ($(shell curl --version 2>/dev/null),)
DOWNLOAD_CMD := curl -f -k -OL
endif
endif
ifeq ($(DOWNLOAD_CMD),)
ifneq ($(shell wget --version 2>/dev/null),)
DOWNLOAD_CMD := wget --no-check-certificate
endif
endif
ifeq ($(DOWNLOAD_CMD),)
DOWNLOAD_CMD := echo "Error: Unable to find curl or wget."; exit 1; \#
endif

default: install

$(PREFIX)/src/expat-$(VERSION).tar.xz:
	mkdir -p $(PREFIX)/src
	cd $(PREFIX)/src/ && $(DOWNLOAD_CMD) https://gr-framework.org/downloads/3rdparty/expat-$(VERSION).tar.xz

$(PREFIX)/src/expat-$(VERSION)/configure: $(PREFIX)/src/expat-$(VERSION).tar.xz
	cd $(PREFIX)/src/ && tar -xf expat-$(VERSION).tar.xz
	touch $@

$(PREFIX)/src/expat-$(VERSION)/Makefile: $(PREFIX)/src/expat-$(VERSION)/configure
	cd $(PREFIX)/src/expat-$(VERSION) && \
	./configure \
		--prefix=$(PREFIX) \
		--libdir=$(PREFIX)/lib \
		--enable-static \
		--disable-shared \
		--with-pic \
		$(EXPAT_EXTRA_CONFIGURE_FLAGS)
	# configure doesn't update the Makefile mtime correctly
	touch $@

$(PREFIX)/lib/libexpat.a: $(PREFIX)/src/expat-$(VERSION)/Makefile
	$(MAKE) -C $(PREFIX)/src/expat-$(VERSION) -j4 && \
	$(MAKE) -C $(PREFIX)/src/expat-$(VERSION) install

libexpat.a: $(PREFIX)/lib/libexpat.a
	cp $(PREFIX)/lib/libexpat.a libexpat.a

clean:
	rm -f libexpat.a

install: $(PREFIX)/lib/libexpat.a

.PHONY: default clean install

=== 3rdparty/ffmpeg/Makefile ===
ifeq ($(strip $(PREFIX)),)
override PREFIX = $(abspath $(CURDIR)/../build)
endif

VERSION = 4.2.1
FFMPEG_EXTRA_CONFIGURE_FLAGS ?=
ifeq ($(shell uname),Darwin)
FFMPEG_EXTRA_CONFIGURE_FLAGS += --extra-cflags=-mmacosx-version-min=10.15
endif


# build for ARMv7 w/ FPU support when using armv8l and requested build arch is armhf
ifeq ($(shell uname -m),armv8l)
ifeq ($(DEB_BUILD_ARCH),armhf)
FFMPEG_EXTRA_CONFIGURE_FLAGS += --cpu=armv7-a+fp
endif
endif


ifeq ($(DOWNLOAD_CMD),)
ifneq ($(shell curl --version 2>/dev/null),)
DOWNLOAD_CMD := curl -k -OL
endif
endif
ifeq ($(DOWNLOAD_CMD),)
ifneq ($(shell wget --version 2>/dev/null),)
DOWNLOAD_CMD := wget --no-check-certificate
endif
endif
ifeq ($(DOWNLOAD_CMD),)
DOWNLOAD_CMD := echo "Error: Unable to find curl or wget."; exit 1; \#
endif

default: install

$(PREFIX)/src/ffmpeg-$(VERSION).tar.gz:
	mkdir -p $(PREFIX)/src
	cd $(PREFIX)/src/ && $(DOWNLOAD_CMD) https://gr-framework.org/downloads/3rdparty/ffmpeg-$(VERSION).tar.gz

$(PREFIX)/src/ffmpeg-$(VERSION)/configure: $(PREFIX)/src/ffmpeg-$(VERSION).tar.gz
	cd $(PREFIX)/src/ && tar -xf ffmpeg-$(VERSION).tar.gz
	sed 's/    \(bcrypt\|clock_gettime\)//' $(PREFIX)/src/ffmpeg-$(VERSION)/configure > $(PREFIX)/src/ffmpeg-$(VERSION)/configure.tmp
	mv $(PREFIX)/src/ffmpeg-$(VERSION)/configure.tmp $(PREFIX)/src/ffmpeg-$(VERSION)/configure
	cd $(PREFIX)/src/ffmpeg-$(VERSION)/libavformat && patch -p1 < $(CURDIR)/mov_pixeldensity.patch
	chmod +x $(PREFIX)/src/ffmpeg-$(VERSION)/configure

$(PREFIX)/src/ffmpeg-$(VERSION)/Makefile: $(PREFIX)/src/ffmpeg-$(VERSION)/configure $(PREFIX)/lib/libtheora.a $(PREFIX)/lib/libvpx.a $(PREFIX)/lib/libopenh264.a
	cd $(PREFIX)/src/ffmpeg-$(VERSION) && \
	PKG_CONFIG_PATH=$(PREFIX)/lib/pkgconfig ./configure \
		--prefix=$(PREFIX) \
		--disable-x86asm \
		--disable-asm \
		--enable-static \
		--disable-shared \
		--enable-pic \
		--enable-libvpx \
		--enable-libtheora \
		--enable-libopenh264 \
		--disable-iconv \
		--extra-cflags=-I$(PREFIX)/include \
		--extra-cxxflags=-I$(PREFIX)/include \
		--extra-ldflags=-L$(PREFIX)/lib \
		--disable-doc \
		--disable-vaapi \
		--disable-postproc \
		--disable-network \
		--disable-programs \
		--disable-encoders \
		--disable-decoders \
		--disable-muxers \
		--disable-demuxers \
		--disable-parsers \
		--disable-bsfs \
		--disable-protocols \
		--disable-devices \
		--disable-filters \
		--disable-vdpau \
		--disable-dxva2 \
		--enable-encoder=libvpx_vp8 \
		--enable-encoder=libtheora \
		--enable-encoder=libopenh264 \
		--enable-encoder=gif \
		--enable-encoder=apng \
		--enable-muxer=webm \
		--enable-muxer=mov \
		--enable-muxer=mp4 \
		--enable-muxer=ogg \
		--enable-muxer=gif \
		--enable-muxer=apng \
		--enable-protocol=file \
		$(FFMPEG_EXTRA_CONFIGURE_FLAGS)
	# configure doesn't update the Makefile mtime correctly
	touch $@

$(PREFIX)/lib/libavformat.a: $(PREFIX)/src/ffmpeg-$(VERSION)/Makefile
	$(MAKE) -C $(PREFIX)/src/ffmpeg-$(VERSION) -j4
	$(MAKE) -C $(PREFIX)/src/ffmpeg-$(VERSION) install

install: $(PREFIX)/lib/libavformat.a


$(PREFIX)/lib/libtheora.a:
	$(MAKE) -C ../theora PREFIX="$(PREFIX)" install

$(PREFIX)/lib/libvpx.a:
	$(MAKE) -C ../vpx PREFIX="$(PREFIX)" install

$(PREFIX)/lib/libopenh264.a:
	$(MAKE) -C ../openh264 PREFIX="$(PREFIX)" install

.PHONY: default install

=== 3rdparty/glfw/Makefile ===
ifeq ($(strip $(PREFIX)),)
override PREFIX = $(abspath $(CURDIR)/../build)
endif

VERSION = 3.3.3
GLFW_EXTRA_CMAKE_FLAGS ?=
ifeq ($(shell uname),Darwin)
 GLFW_EXTRA_CMAKE_FLAGS += -DCMAKE_OSX_DEPLOYMENT_TARGET=10.15
endif

ifeq ($(DOWNLOAD_CMD),)
ifneq ($(shell curl --version 2>/dev/null),)
DOWNLOAD_CMD := curl -k -OL
endif
endif
ifeq ($(DOWNLOAD_CMD),)
ifneq ($(shell wget --version 2>/dev/null),)
DOWNLOAD_CMD := wget --no-check-certificate
endif
endif
ifeq ($(DOWNLOAD_CMD),)
DOWNLOAD_CMD := echo "Error: Unable to find curl or wget."; exit 1; \#
endif

ifeq ($(CMAKE_CMD),)
ifneq ($(shell cmake --version 2>/dev/null),)
CMAKE_CMD := cmake
CMAKE_DEP :=
endif
endif
ifeq ($(CMAKE_CMD),)
CMAKE_CMD := $(PREFIX)/bin/cmake
CMAKE_DEP := $(CMAKE_CMD)
endif

default: install

$(PREFIX)/src/glfw-$(VERSION).tar.gz:
	mkdir -p $(PREFIX)/src
	cd $(PREFIX)/src/ && $(DOWNLOAD_CMD) https://gr-framework.org/downloads/3rdparty/glfw-$(VERSION).tar.gz

$(PREFIX)/src/glfw-$(VERSION)/CMakeLists.txt: $(PREFIX)/src/glfw-$(VERSION).tar.gz
	cd $(PREFIX)/src/ && tar -xf glfw-$(VERSION).tar.gz
	touch $@

$(PREFIX)/build/glfw-$(VERSION)/Makefile: $(PREFIX)/src/glfw-$(VERSION)/CMakeLists.txt $(CMAKE_DEP)
	mkdir -p $(PREFIX)/build/glfw-$(VERSION)
	cd $(PREFIX)/build/glfw-$(VERSION) && \
	$(CMAKE_CMD) \
		-DCMAKE_INSTALL_PREFIX:PATH=${PREFIX} \
		-DGLFW_USE_RETINA=OFF \
		-DGLFW_BUILD_EXAMPLES=OFF \
		-DGLFW_BUILD_DOCS=OFF \
		-DGLFW_BUILD_TESTS=OFF \
		$(GLFW_EXTRA_CMAKE_FLAGS) \
		$(PREFIX)/src/glfw-$(VERSION)/

$(PREFIX)/lib/libglfw3.a: $(PREFIX)/build/glfw-$(VERSION)/Makefile
	$(MAKE) -C $(PREFIX)/build/glfw-$(VERSION) -j4
	$(MAKE) -C $(PREFIX)/build/glfw-$(VERSION) install

install: $(PREFIX)/lib/libglfw3.a

.PHONY: default install

=== 3rdparty/libpng16/Makefile ===
ifeq ($(strip $(PREFIX)),)
override PREFIX = $(abspath $(CURDIR)/../build)
endif

 PNGCFLAGS = -O -I. -I../zlib/ -fPIC -fno-common $(PNG_EXTRA_CFLAGS) $(ARCHS)
ifeq ($(shell uname),Darwin)
ifneq ($(notdir $(CC)),emcc)
PNGCFLAGS += -mmacosx-version-min=10.15
ifeq ($(shell arch),arm64)
PNGCFLAGS += -DPNG_ARM_NEON_OPT=0
endif
endif
endif
ifeq ($(shell arch),aarch64)
PNGCFLAGS += -DPNG_ARM_NEON_OPT=0
endif
      OBJS = \
	png.o \
	pngerror.o \
	pngget.o \
	pngmem.o \
	pngpread.o \
	pngread.o \
	pngrio.o \
	pngrtran.o \
	pngrutil.o \
	pngset.o \
	pngtrans.o \
	pngwio.o \
	pngwrite.o \
	pngwtran.o \
	pngwutil.o

.c.o:
	$(CC) $(PNGCFLAGS) -o $@ -c $<

default: install

libpng.a: $(OBJS)
	$(AR) crv $@ $?
	$(AR) ts $@

distclean: clean

clean:
	rm -f libpng.a *.o *.bak

depend:
	makedepend -Y -- \
	png.c \
	pngerror.c \
	pngget.c \
	pngmem.c \
	pngpread.c \
	pngread.c \
	pngrio.c \
	pngrtran.c \
	pngrutil.c \
	pngset.c \
	pngtrans.c \
	pngwio.c \
	pngwrite.c \
	pngwtran.c \
	pngwutil.c

$(PREFIX)/lib/libpng.a: libpng.a
	mkdir -p $(PREFIX)/lib/
	mkdir -p $(PREFIX)/include/
	cp libpng.a $(PREFIX)/lib/
	cp *.h $(PREFIX)/include/

install: $(PREFIX)/lib/libpng.a

.PHONY: default install clean distclean depend

# DO NOT DELETE THIS LINE -- make depend depends on it.

png.o: png.h
pngerror.o: png.h
pngget.o: png.h
pngmem.o: png.h
pngpread.o: png.h
pngread.o: png.h
pngrio.o: png.h
pngrtran.o: png.h
pngrutil.o: png.h
pngset.o: png.h
pngtrans.o: png.h
pngwio.o: png.h
pngwrite.o: png.h
pngwtran.o: png.h
pngwutil.o: png.h

=== 3rdparty/libxml2/Makefile ===
ifeq ($(strip $(PREFIX)),)
override PREFIX = $(abspath $(CURDIR)/../build)
endif

VERSION = 2.10.4
LIBXML2_EXTRA_CONFIGURE_FLAGS ?=
ifeq ($(shell uname),Darwin)
LIBXML2_EXTRA_CONFIGURE_FLAGS += CFLAGS=-mmacosx-version-min=10.15
endif

ifeq ($(DOWNLOAD_CMD),)
ifneq ($(shell curl --version 2>/dev/null),)
DOWNLOAD_CMD := curl -f -k -OL
endif
endif
ifeq ($(DOWNLOAD_CMD),)
ifneq ($(shell wget --version 2>/dev/null),)
DOWNLOAD_CMD := wget --no-check-certificate
endif
endif
ifeq ($(DOWNLOAD_CMD),)
DOWNLOAD_CMD := echo "Error: Unable to find curl or wget."; exit 1; \#
endif

default: install

$(PREFIX)/src/libxml2-$(VERSION).tar.xz:
	mkdir -p $(PREFIX)/src
	cd $(PREFIX)/src/ && $(DOWNLOAD_CMD) https://gr-framework.org/downloads/3rdparty/libxml2-$(VERSION).tar.xz

$(PREFIX)/src/libxml2-$(VERSION)/configure: $(PREFIX)/src/libxml2-$(VERSION).tar.xz
	cd $(PREFIX)/src/ && tar -xf libxml2-$(VERSION).tar.xz
	touch $@

$(PREFIX)/src/libxml2-$(VERSION)/Makefile: $(PREFIX)/src/libxml2-$(VERSION)/configure
	cd $(PREFIX)/src/libxml2-$(VERSION) && \
	./configure \
		--prefix=$(PREFIX) \
		--libdir=$(PREFIX)/lib \
		--enable-static \
		--disable-shared \
		--with-pic \
		--with-zlib=$(PREFIX) \
		--without-python \
		$(LIBXML2_EXTRA_CONFIGURE_FLAGS)
	# configure doesn't update the Makefile mtime correctly
	touch $@

$(PREFIX)/lib/libxml2.a: $(PREFIX)/src/libxml2-$(VERSION)/Makefile
	$(MAKE) -C $(PREFIX)/src/libxml2-$(VERSION) -j4 && \
	$(MAKE) -C $(PREFIX)/src/libxml2-$(VERSION) install

libxml2.a: $(PREFIX)/lib/libxml2.a
	cp $(PREFIX)/lib/libxml2.a libxml2.a

clean:
	rm -f libxml2.a

install: $(PREFIX)/lib/libxml2.a

.PHONY: default clean install

=== 3rdparty/pixman/Makefile ===
ifeq ($(strip $(PREFIX)),)
override PREFIX = $(abspath $(CURDIR)/../build)
endif

VERSION = 0.42.2
PIXMAN_EXTRA_CONFIGURE_FLAGS ?=
ifeq ($(shell uname),Darwin)
PIXMAN_EXTRA_CONFIGURE_FLAGS += CFLAGS=-mmacosx-version-min=10.15
endif

ifeq ($(DOWNLOAD_CMD),)
ifneq ($(shell curl --version 2>/dev/null),)
DOWNLOAD_CMD := curl -k -OL
endif
endif
ifeq ($(DOWNLOAD_CMD),)
ifneq ($(shell wget --version 2>/dev/null),)
DOWNLOAD_CMD := wget --no-check-certificate
endif
endif
ifeq ($(DOWNLOAD_CMD),)
DOWNLOAD_CMD := echo "Error: Unable to find curl or wget."; exit 1; \#
endif

default: install

$(PREFIX)/src/pixman-$(VERSION).tar.gz:
	mkdir -p $(PREFIX)/src
	cd $(PREFIX)/src/ && $(DOWNLOAD_CMD) https://gr-framework.org/downloads/3rdparty/pixman-$(VERSION).tar.gz

$(PREFIX)/src/pixman-$(VERSION)/configure: $(PREFIX)/src/pixman-$(VERSION).tar.gz
	cd $(PREFIX)/src/ && tar -xf pixman-$(VERSION).tar.gz
	cd $(PREFIX)/src/pixman-$(VERSION) && patch -p1 < $(CURDIR)/arm-a64-neon.patch
	touch $@

$(PREFIX)/src/pixman-$(VERSION)/Makefile: $(PREFIX)/src/pixman-$(VERSION)/configure
	cd $(PREFIX)/src/pixman-$(VERSION) && ./configure \
		--prefix=$(PREFIX) \
		--libdir=$(PREFIX)/lib \
		--disable-shared \
		--enable-static \
		--with-pic \
		--disable-dependency-tracking \
                --disable-silent-rules \
		$(PIXMAN_EXTRA_CONFIGURE_FLAGS)
	# Do not build tests or demos
	cp dummy.Makefile $(PREFIX)/src/pixman-$(VERSION)/test/Makefile
	cp dummy.Makefile $(PREFIX)/src/pixman-$(VERSION)/demos/Makefile

$(PREFIX)/lib/libpixman-1.a: $(PREFIX)/src/pixman-$(VERSION)/Makefile
	$(MAKE) -C $(PREFIX)/src/pixman-$(VERSION) -j4
	$(MAKE) -C $(PREFIX)/src/pixman-$(VERSION) install

install: $(PREFIX)/lib/libpixman-1.a

.PHONY: default install

=== 3rdparty/theora/Makefile ===
ifeq ($(strip $(PREFIX)),)
override PREFIX = $(abspath $(CURDIR)/../build)
endif

VERSION = 1.1.1
THEORA_CONFIGURE ?= ./configure
THEORA_EXTRA_CONFIGURE_FLAGS ?=
ifeq ($(shell uname),Darwin)
THEORA_EXTRA_CONFIGURE_FLAGS += CFLAGS=-mmacosx-version-min=10.15
endif

ifeq ($(DOWNLOAD_CMD),)
ifneq ($(shell curl --version 2>/dev/null),)
DOWNLOAD_CMD := curl -k -OL
endif
endif
ifeq ($(DOWNLOAD_CMD),)
ifneq ($(shell wget --version 2>/dev/null),)
DOWNLOAD_CMD := wget --no-check-certificate
endif
endif
ifeq ($(DOWNLOAD_CMD),)
DOWNLOAD_CMD := echo "Error: Unable to find curl or wget."; exit 1; \#
endif

default: install

$(PREFIX)/src/libtheora-$(VERSION).tar.gz:
	mkdir -p $(PREFIX)/src
	cd $(PREFIX)/src/ && $(DOWNLOAD_CMD) https://gr-framework.org/downloads/3rdparty/libtheora-$(VERSION).tar.gz

$(PREFIX)/src/libtheora-$(VERSION)/configure: $(PREFIX)/src/libtheora-$(VERSION).tar.gz
	cd $(PREFIX)/src/ && tar -xf libtheora-$(VERSION).tar.gz
	cd $(PREFIX)/src/ && patch -p0 < $(CURDIR)/libtheora.patch
	cp $(CURDIR)/config.guess $(CURDIR)/config.sub $$(dirname $@)
	touch $@

$(PREFIX)/src/libtheora-$(VERSION)/Makefile: $(PREFIX)/src/libtheora-$(VERSION)/configure $(PREFIX)/lib/libogg.a
	cd $(PREFIX)/src/libtheora-$(VERSION) && \
	$(THEORA_CONFIGURE) \
		--prefix=$(PREFIX) \
		--libdir=$(PREFIX)/lib \
		--enable-static \
		--disable-shared \
		--with-pic \
		--disable-dependency-tracking \
		--disable-spec \
		--disable-examples \
		--includedir=$(PREFIX)/include \
		--with-ogg-includes=$(PREFIX)/include \
		--with-ogg-libraries=$(PREFIX)/lib \
		$(THEORA_EXTRA_CONFIGURE_FLAGS)

$(PREFIX)/lib/libtheora.a: $(PREFIX)/src/libtheora-$(VERSION)/Makefile
	$(MAKE) -C $(PREFIX)/src/libtheora-$(VERSION) -j4
	$(MAKE) -C $(PREFIX)/src/libtheora-$(VERSION) install

install: $(PREFIX)/lib/libtheora.a


$(PREFIX)/lib/libogg.a:
	$(MAKE) -C ../ogg PREFIX="$(PREFIX)" install

.PHONY: default install

=== 3rdparty/tiff/Makefile ===
ifeq ($(strip $(PREFIX)),)
override PREFIX = $(abspath $(CURDIR)/../build)
endif

VERSION = 4.5.1
TIFF_EXTRA_CONFIGURE_FLAGS ?=
ifeq ($(shell uname),Darwin)
 TIFF_EXTRA_CONFIGURE_FLAGS += CFLAGS=-mmacosx-version-min=10.15
endif

ifeq ($(DOWNLOAD_CMD),)
ifneq ($(shell curl --version 2>/dev/null),)
DOWNLOAD_CMD := curl -k -OL
endif
endif
ifeq ($(DOWNLOAD_CMD),)
ifneq ($(shell wget --version 2>/dev/null),)
DOWNLOAD_CMD := wget --no-check-certificate
endif
endif
ifeq ($(DOWNLOAD_CMD),)
DOWNLOAD_CMD := echo "Error: Unable to find curl or wget."; exit 1; \#
endif

default: install

$(PREFIX)/src/tiff-$(VERSION).tar.gz:
	mkdir -p $(PREFIX)/src
	cd $(PREFIX)/src/ && $(DOWNLOAD_CMD) https://gr-framework.org/downloads/3rdparty/tiff-$(VERSION).tar.gz

$(PREFIX)/src/tiff-$(VERSION)/configure: $(PREFIX)/src/tiff-$(VERSION).tar.gz
	cd $(PREFIX)/src/ && tar -xf tiff-$(VERSION).tar.gz
	touch $@

$(PREFIX)/src/tiff-$(VERSION)/Makefile: $(PREFIX)/src/tiff-$(VERSION)/configure
	cd $(PREFIX)/src/tiff-$(VERSION) && \
	./configure \
		--prefix=$(PREFIX) \
		--libdir=$(PREFIX)/lib \
		--enable-static \
		--disable-shared \
		--with-pic \
		--disable-dependency-tracking \
		--with-zlib-include-dir=$(PREFIX)/include/ \
		--with-zlib-lib-dir=$(PREFIX)/lib/ \
		--disable-largefile \
		--disable-ccitt \
		--disable-packbits \
		--disable-lzw \
		--disable-thunder \
		--disable-next \
		--disable-logluv \
		--disable-mdi \
		--disable-pixarlog \
		--disable-jpeg \
		--disable-old-jpeg \
		--disable-jbig \
		--disable-lzma \
		--disable-zstd \
		--disable-webp \
		$(TIFF_EXTRA_CONFIGURE_FLAGS)

$(PREFIX)/lib/libtiff.a: $(PREFIX)/src/tiff-$(VERSION)/Makefile
	$(MAKE) -C $(PREFIX)/src/tiff-$(VERSION) -j4
	$(MAKE) -C $(PREFIX)/src/tiff-$(VERSION) install

install: $(PREFIX)/lib/libtiff.a

.PHONY: default install

=== lib/gks/Makefile ===
ifeq ($(strip $(THIRDPARTYDIR)),)
override THIRDPARTYDIR = $(abspath $(CURDIR)/../../3rdparty/build)
endif

            GRDIR = /usr/local/gr
           BINDIR = $(DESTDIR)$(GRDIR)/bin
           LIBDIR = $(DESTDIR)$(GRDIR)/lib
           INCDIR = $(DESTDIR)$(GRDIR)/include
          FONTDIR = $(DESTDIR)$(GRDIR)/fonts

ifeq ($(shell arch), arm64)
    ARCH = arm64
else
    ARCH = x86_64
endif

UNAME := $(shell uname)

     GKSOBJS = gks.o gksforbnd.o font.o afm.o util.o dl.o malloc.o \
               error.o mf.o wiss.o win.o ps.o pdf.o socket.o \
               plugin.o compress.o io.o ft.o resample.o

      GSDEFS =
          CC = cc
     DEFINES = -DHAVE_ZLIB $(GSDEFS)
      CFLAGS = -O3 -Wall -Wextra -ansi -pedantic -fPIC $(EXTRA_CFLAGS)
          LD = cc
          AR = ar
      RANLIB = ar ts
ifeq ($(UNAME), Darwin)
GR_SHARED_LIBRARY_SUFFIX ?= .dylib
	 CFLAGS += -mmacosx-version-min=10.15
INSTALL_NAME = -Wl,-install_name,@rpath/libGKS${GR_SHARED_LIBRARY_SUFFIX}
     LDFLAGS = $(EXTRA_LDFLAGS) -Wl,-rpath,@loader_path/. -mmacosx-version-min=10.15
     SOFLAGS = -dynamiclib
else
GR_SHARED_LIBRARY_SUFFIX ?= .so
INSTALL_NAME =
     LDFLAGS = $(EXTRA_LDFLAGS) -Wl,-rpath,'$$ORIGIN/.'
     SOFLAGS = -shared
endif
        LIBS = -lpthread -ldl -lc -lm
      FTDEFS =
       FTINC = -I$(THIRDPARTYDIR)/include
      FTLIBS = $(THIRDPARTYDIR)/lib/libfreetype.a
        ZINC = -I$(THIRDPARTYDIR)/include
       ZLIBS = $(THIRDPARTYDIR)/lib/libz.a

.c.o:
	$(CC) -c -DGRDIR=\"$(GRDIR)\" $(DEFINES) $(FTINC) $(ZINC) $(CFLAGS) $<

default:
	$(MAKE) -C ../.. Makedefs
	$(MAKE) `cat ../../Makedefs`

all: targets

targets: libGKS.a libGKS${GR_SHARED_LIBRARY_SUFFIX} demo gksm plugins gksqt

ifeq ($(UNAME), Darwin)
targets: gksterm
endif

$(THIRDPARTYDIR)/lib/libz.a:
	$(MAKE) -C ../../3rdparty/zlib PREFIX=$(THIRDPARTYDIR)

$(THIRDPARTYDIR)/lib/libfreetype.a:
	$(MAKE) -C ../../3rdparty/freetype PREFIX=$(THIRDPARTYDIR)

$(THIRDPARTYDIR)/lib/libzmq.a:
	$(MAKE) -C ../../3rdparty/zeromq PREFIX=$(THIRDPARTYDIR)

libGKS.a: $(GKSOBJS)
	$(AR) crv $@ $?
	$(RANLIB) $@

libGKS${GR_SHARED_LIBRARY_SUFFIX}: $(GKSOBJS) $(THIRDPARTYDIR)/lib/libfreetype.a $(THIRDPARTYDIR)/lib/libz.a
	$(CC) -o $@ $(SOFLAGS) $(GKSOBJS) $(FTLIBS) $(ZLIBS) $(LIBS) \
	$(LDFLAGS) $(INSTALL_NAME)

demo: demo.c libGKS.a $(THIRDPARTYDIR)/lib/libfreetype.a $(THIRDPARTYDIR)/lib/libz.a
	$(CC) -o demo $(LDFLAGS) demo.c libGKS.a $(FTLIBS) $(ZLIBS) $(LIBS)

gksm: gksm.c libGKS.a $(THIRDPARTYDIR)/lib/libfreetype.a $(THIRDPARTYDIR)/lib/libz.a
	$(CC) -o gksm $(LDFLAGS) gksm.c libGKS.a $(FTLIBS) $(ZLIBS) $(LIBS)

gksqt:
	$(MAKE) -C qt -f makefile.mak GRDIR=$(GRDIR)

ifeq ($(UNAME), Darwin)
gksterm: $(THIRDPARTYDIR)/lib/libzmq.a
	(env CC=cc xcodebuild -arch $(ARCH) -project quartz/GKSTerm.xcodeproj)
endif

ifeq ($(UNAME), Darwin)
plugins: $(THIRDPARTYDIR)/lib/libzmq.a
	$(MAKE) -C plugin
else
plugins:
	$(MAKE) -C plugin
endif

pasdemo: default
	fpc demo.p -g -Fl./ -k-rpath -k./

install:
	@if [ ! -d $(DESTDIR)$(GRDIR) ]; then mkdir -m 755 $(DESTDIR)$(GRDIR); fi
	@if [ ! -d $(LIBDIR) ]; then mkdir -m 755 $(LIBDIR); fi
	cp -p libGKS.* $(LIBDIR)
	cp -p plugin/*plugin.so $(LIBDIR)
	@if [ ! -d $(BINDIR) ]; then mkdir -m 755 $(BINDIR); fi
	cp -p gksm $(BINDIR)
	@if [ ! -d $(FONTDIR) ]; then mkdir -m 755 $(FONTDIR); fi
	cp -a fonts/* $(FONTDIR)
	@if [ ! -d $(INCDIR) ]; then mkdir -m 755 $(INCDIR); fi
	cp -p gks.h $(INCDIR)
	$(MAKE) -C qt -f makefile.mak install
ifeq ($(UNAME), Darwin)
	@if [ ! -d $(DESTDIR)$(GRDIR)/Applications ]; then \
	mkdir -m 755 $(DESTDIR)$(GRDIR)/Applications; fi
	@ditto quartz/build/Release/GKSTerm.app \
	$(DESTDIR)$(GRDIR)/Applications/GKSTerm.app
endif

clean:
	$(MAKE) -C plugin clean
	$(MAKE) -C qt -f makefile.mak clean
	rm -f qt/.qmake.stash
	rm -f demo gksm pasdemo so_locations *.so *.a *.o *.ppu link.res *${GR_SHARED_LIBRARY_SUFFIX}
	rm -f *.bak *~
ifeq ($(UNAME), Darwin)
	(env CC=cc xcodebuild -arch $(ARCH) -project quartz/GKSTerm.xcodeproj clean)
endif
	cp -p quartz/project.pbxproj quartz/GKSTerm.xcodeproj/

depend:
	makedepend -Y -- \
	gks.c gksforbnd.c font.c afm.c util.c dl.c malloc.c error.c \
	mf.c wiss.c win.c ps.c pdf.c socket.c plugin.c \
	compress.c io.c ft.c resample.c 2> /dev/null

.PHONY: default all targets prerequisites plugins install clean depend

ft.o: $(THIRDPARTYDIR)/lib/libfreetype.a
pdf.o: $(THIRDPARTYDIR)/lib/libz.a

# DO NOT DELETE THIS LINE -- make depend depends on it.

gks.o: gks.h gkscore.h
gksforbnd.o: gks.h gksforbnd.h
font.o: gks.h gkscore.h
afm.o: gkscore.h
util.o: gks.h gkscore.h
dl.o: gks.h gkscore.h
malloc.o: gkscore.h
error.o: gkscore.h
mf.o: gkscore.h gks.h
wiss.o: gks.h gkscore.h
win.o: gks.h gkscore.h
ps.o: gks.h gkscore.h
pdf.o: gks.h gkscore.h
socket.o: gks.h gkscore.h
plugin.o: gkscore.h
compress.o: gkscore.h
io.o: gkscore.h

=== lib/gr/qtgr/Makefile ===
LIBDIR = $(DESTDIR)$(GRDIR)/lib
INCDIR = $(DESTDIR)$(GRDIR)/include

UNAME_S := $(shell uname -s)

CFLAGS = -O3 -Wall -fPIC $(EXTRA_CFLAGS)
LDFLAGS = $(EXTRA_LDFLAGS)


ifeq ($(UNAME_S),Darwin)
GR_SHARED_LIBRARY_SUFFIX ?= .dylib
else
GR_SHARED_LIBRARY_SUFFIX ?= .so
endif

ifneq ($(QT4_QMAKE),false)
QT4INCDIR = `$(QT4_QMAKE) -query QT_INSTALL_HEADERS`
QT4INC = -I$(QT4INCDIR) -I$(QT4INCDIR)/QtCore -I$(QT4INCDIR)/QtGui
ifeq ($(UNAME_S),Darwin)
ifneq ($(QT4INC),)
	QT4INC += -mmacosx-version-min=10.15
endif
endif
QT4LIBDIR = `$(QT4_QMAKE) -query QT_INSTALL_LIBS`
QT4LIBS = -L$(QT4LIBDIR) -lQtGui -lQtCore
endif

ifneq ($(QT5_QMAKE),false)
QT5DEFS =
QT5INCDIR = `$(QT5_QMAKE) -query QT_INSTALL_HEADERS`
ifeq ($(UNAME_S),Darwin)
	QT5INC = -I$(QT5INCDIR) -I$(QT5LIBDIR)/QtCore.framework/Versions/5/Headers -I$(QT5LIBDIR)/QtGui.framework/Versions/5/Headers -I$(QT5LIBDIR)/QtWidgets.framework/Versions/5/Headers -F$(QT5LIBDIR)
else
	QT5INC = -I$(QT5INCDIR) -I$(QT5INCDIR)/QtCore -I$(QT5INCDIR)/QtGui -I$(QT5INCDIR)/QtWidgets
endif
QT5INC += -std=c++11
QT5LIBDIR = `$(QT5_QMAKE) -query QT_INSTALL_LIBS`
ifeq ($(UNAME_S),Darwin)
	QT5LIBS = -F$(QT5LIBDIR) -framework QtWidgets -framework QtGui -framework QtCore
else
	QT5LIBS = -L$(QT5LIBDIR) -lQt5Widgets -lQt5Gui -lQt5Core
endif
endif

ifneq ($(QT6_QMAKE),false)
QT6DEFS =
QT6INCDIR = `$(QT6_QMAKE) -query QT_INSTALL_HEADERS`
ifeq ($(UNAME_S),Darwin)
	QT6INC = -I$(QT6INCDIR) -I$(QT6LIBDIR)/QtCore.framework/Versions/A/Headers -I$(QT6LIBDIR)/QtGui.framework/Versions/A/Headers -I$(QT6LIBDIR)/QtWidgets.framework/Versions/A/Headers -F$(QT6LIBDIR)
else
	QT6INC = -I$(QT6INCDIR) -I$(QT6INCDIR)/QtCore -I$(QT6INCDIR)/QtGui -I$(QT6INCDIR)/QtWidgets
endif
QT6INC += -std=c++17
QT6LIBDIR = `$(QT6_QMAKE) -query QT_INSTALL_LIBS`
ifeq ($(UNAME_S),Darwin)
	QT6LIBS = -F$(QT6LIBDIR) -framework QtWidgets -framework QtGui -framework QtCore
else
	QT6LIBS = -L$(QT6LIBDIR) -lQt6Widgets -lQt6Gui -lQt6Core
endif
endif

ifeq ($(UNAME_S),Darwin)
	LIBQT4GR_INSTALL_NAME = -Wl,-install_name,@rpath/libqt4gr${GR_SHARED_LIBRARY_SUFFIX}
	LIBQT5GR_INSTALL_NAME = -Wl,-install_name,@rpath/libqt5gr${GR_SHARED_LIBRARY_SUFFIX}
	LIBQT6GR_INSTALL_NAME = -Wl,-install_name,@rpath/libqt6gr${GR_SHARED_LIBRARY_SUFFIX}
else
	LIBQT4GR_INSTALL_NAME =
	LIBQT5GR_INSTALL_NAME =
	LIBQT6GR_INSTALL_NAME =
endif

GRINC = -I..
GRLIBS = -L.. -lGR


default:
	$(MAKE) -C ../../.. Makedefs
	$(MAKE) `cat ../../../Makedefs`

all: targets

targets: libqt4gr${GR_SHARED_LIBRARY_SUFFIX} libqt5gr${GR_SHARED_LIBRARY_SUFFIX} libqt6gr${GR_SHARED_LIBRARY_SUFFIX}

ifneq ($(QT4_QMAKE),false)
libqt4gr${GR_SHARED_LIBRARY_SUFFIX}: grwidget_qt4.o
	$(CXX) -shared -o $@ $^ $(LDFLAGS) $(QT4LIBS) $(GRLIBS) $(LIBQT4GR_INSTALL_NAME)

grwidget_qt4.o: grwidget.cxx
	$(CXX) -o $@ -c $(CFLAGS) $(QT4INC) $(GRINC) $<
else
libqt4gr${GR_SHARED_LIBRARY_SUFFIX}:
endif

ifneq ($(QT5_QMAKE),false)
libqt5gr${GR_SHARED_LIBRARY_SUFFIX}: grwidget_qt5.o
	$(CXX) -shared -o $@ $^ $(LDFLAGS) $(QT5LIBS) $(GRLIBS) $(LIBQT5GR_INSTALL_NAME)

grwidget_qt5.o: grwidget.cxx
	$(CXX) -o $@ -c $(CFLAGS) $(QT5INC) $(GRINC) $<
else
libqt5gr${GR_SHARED_LIBRARY_SUFFIX}:
endif

ifneq ($(QT6_QMAKE),false)
libqt6gr${GR_SHARED_LIBRARY_SUFFIX}: grwidget_qt6.o
	$(CXX) -shared -o $@ $^ $(LDFLAGS) $(QT6LIBS) $(GRLIBS) $(LIBQT6GR_INSTALL_NAME)

grwidget_qt6.o: grwidget.cxx
	$(CXX) -o $@ -c $(CFLAGS) $(QT6INC) $(GRINC) $<
else
libqt6gr${GR_SHARED_LIBRARY_SUFFIX}:
endif

install:
ifneq (false false,$(filter false,$(QT4_QMAKE) $(QT5_QMAKE) $(QT6_QMAKE)))   # install only if any Qt is present
	@if [ ! -d $(LIBDIR) ]; then mkdir -m 755 $(LIBDIR); fi
	cp -p libqt*.* $(LIBDIR)
	@if [ ! -d $(INCDIR) ]; then mkdir -m 755 $(INCDIR); fi
	cp -p grwidget.h $(INCDIR)
endif

clean:
	rm -f *.so *.o *${GR_SHARED_LIBRARY_SUFFIX}

.PHONY: default all targets install clean

=== PKGBUILD ===
# Maintainer: Sutou Kouhei <kou@clear-code.com>

_realname=gr
pkgbase=mingw-w64-${_realname}
pkgname="${MINGW_PACKAGE_PREFIX}-${_realname}"
pkgver=0.73.5
pkgrel=1
pkgdesc="A graphics library for visualisation applications (mingw-w64)"
arch=(any)
mingw_arch=('mingw64' 'ucrt64' 'clang64' 'clangarm64')
url="https://gr-framework.org/"
msys2_repository_url="https://github.com/sciapp/gr"
msys2_references=(
  'aur: gr-framework'
)
license=("spdx:MIT")
depends=("${MINGW_PACKAGE_PREFIX}-bzip2"
         "${MINGW_PACKAGE_PREFIX}-cairo"
         "${MINGW_PACKAGE_PREFIX}-ffmpeg"
         "${MINGW_PACKAGE_PREFIX}-freetype"
         "${MINGW_PACKAGE_PREFIX}-fontconfig"
         "${MINGW_PACKAGE_PREFIX}-glfw"
         "${MINGW_PACKAGE_PREFIX}-libjpeg"
         "${MINGW_PACKAGE_PREFIX}-libpng"
         "${MINGW_PACKAGE_PREFIX}-libtiff"
         "${MINGW_PACKAGE_PREFIX}-qhull"
         "${MINGW_PACKAGE_PREFIX}-qt5-base"
         "${MINGW_PACKAGE_PREFIX}-qt6-base"
         "${MINGW_PACKAGE_PREFIX}-zlib"
         "${MINGW_PACKAGE_PREFIX}-zeromq")
makedepends=("${MINGW_PACKAGE_PREFIX}-cc"
             "${MINGW_PACKAGE_PREFIX}-cmake"
             "${MINGW_PACKAGE_PREFIX}-ninja")
source=("https://github.com/sciapp/gr/archive/v${pkgver}/${_realname}-${pkgver}.tar.gz"
        "0001-support-mingw-wcstok.patch")
sha256sums=('834f5c0185cdd9750c4a9e4b1c2c1c3cf63f8b49ba62165a3de2dcbf1d072b9e'
            'c3209d0ea7816b24549766cce3dabe21b81d1f4ddc9dd752b132a1db9c79f8be')
noextract=("${_realname}-${pkgver}.tar.gz")

prepare() {
  # We can't use bsdtar to extract the archive because the archive includes
  # symbolic link.
  rm -rf "${_realname}-${pkgver}"
  tar -xf "${_realname}-${pkgver}.tar.gz" || true

  cd "${srcdir}/${_realname}-${pkgver}"

  # Set version manually, otherwise it resets to zero
  echo "${pkgver}" > version.txt
  sed -i "s|\${GR_VERSION}|${pkgver}|g" CMakeLists.txt

  patch -p1 -i "${srcdir}/0001-support-mingw-wcstok.patch"
}

build() {
  mkdir -p "${srcdir}/build-${MSYSTEM}" && cd "${srcdir}/build-${MSYSTEM}"

  declare -a _extra_config
  if check_option "debug" "n"; then
    _extra_config+=("-DCMAKE_BUILD_TYPE=Release")
  else
    _extra_config+=("-DCMAKE_BUILD_TYPE=Debug")
  fi

  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
    ${MINGW_PREFIX}/bin/cmake.exe \
    -G "Ninja" \
    -DCMAKE_INSTALL_PREFIX=${MINGW_PREFIX} \
    -DGR_USE_BUNDLED_LIBRARIES=OFF \
    -DQHULL_VERSION_STRING="2020.2" \
    "${_extra_config[@]}" \
    ../${_realname}-${pkgver}

  ${MINGW_PREFIX}/bin/cmake.exe --build ./
}

package() {
  cd "${srcdir}/build-${MSYSTEM}"
  DESTDIR="${pkgdir}" ${MINGW_PREFIX}/bin/cmake.exe --install .

  install -Dm644 "${srcdir}"/${_realname}-${pkgver}/LICENSE.md "${pkgdir}${MINGW_PREFIX}/share/licenses/${_realname}/LICENSE.md"
}
